""" The pdelab specific parts of the code generation process """

# Define the generators that are used throughout all pdelab specific code generations.
from dune.perftool.generation import generator_factory
from dune.perftool.loopy.transformer import quadrature_iname
from loopy import CInstruction

dune_symbol = generator_factory(item_tags=("pdelab", "kernel", "symbol"))
dune_preamble = generator_factory(item_tags=("pdelab", "kernel", "preamble"), counted=True)
dune_include = generator_factory(on_store=lambda i: "#include<{}>".format(i), item_tags=("pdelab", "include"), no_deco=True)


def quadrature_preamble(assignees=[]):
    # TODO: How to enforce the order of quadrature preambles? Counted?
    return generator_factory(item_tags=("pdelab", "instruction", "cinstruction", "quadrature"), on_store=lambda code: CInstruction(quadrature_iname(), code, assignees=assignees))


# Now define some commonly used generators that do not fall into a specific category
@dune_symbol
def name_index(index):
    return str(index._indices[0])
